/*
    LVP - displays the menu on a Linux Video Project CD/DVD
    Copyright (C) 2003 Benjamin Schieder

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <GL/glut.h>
#include "gli.h"
#include "string.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

int WindW, WindH;
int lvpxml;
char *buf, *work;

int buttonx = 0;
int buttony = 0;
int no_eternity = 0;
int reading = 0;
int items = 0;

CGLI_Interface iface;
CGLI_Interface iface_exit;
CGLI_Interface iface_texture;
CGLI_Interface iface_buttons;

int draw_iface=1;
int draw_iface_texture=1;
int draw_iface_exit=0;

int ifaceposition=0;
CGLI_Window2D window;
CGLI_Button2D button_exit;
CGLI_Button2D yes, no, up, down;
CGLI_String window_text;
CGLI_Text memo;
#define UP 1
#define DOWN 2
#define STOP 0
int direction = STOP;

char *action[64];
unsigned int ids[64];

void Reshape(int width, int height){ /* {{{ */
	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	
	//if (width <= height)
		//glOrtho(-100.0, 100.0, -100.0*(GLfloat)height/(GLfloat)width, 100.0*(GLfloat)height/(GLfloat)width, -100.0, 100.0);
	//else
		//glOrtho(-100.0*(GLfloat)width/(GLfloat)height, 100.0*(GLfloat)width/(GLfloat)height, -100.0, 100.0, -100.0, 100.0);
	glOrtho(-100*1.33, 100*1.33, -100, 100, -100, 100);
	glMatrixMode(GL_MODELVIEW);

	WindW = width;
	WindH = height;
} /* }}} */
void mouse(int button, int state, int x, int y){ /* {{{ */
	switch (button)
	{
		case GLUT_LEFT_BUTTON: button = GLI_MOUSE_BUTTON_LEFT; break;
		case GLUT_MIDDLE_BUTTON: button = GLI_MOUSE_BUTTON_MIDDLE; break;
		case GLUT_RIGHT_BUTTON: button = GLI_MOUSE_BUTTON_RIGHT; break;
	}
	switch (state)
	{
		case GLUT_DOWN: state = GLI_MOUSE_BUTTON_DOWN; break;
		case GLUT_UP: state = GLI_MOUSE_BUTTON_UP; break;
	}
	if (draw_iface==1){
		iface.SendMouseParameters(GLI_MOUSE_CLICK, button, state, x, WindH-y);
	}
	if (draw_iface_texture==1){
		iface_texture.SendMouseParameters(GLI_MOUSE_CLICK, button, state, x, WindH-y);
	}
	if (draw_iface_exit==1){
		iface_exit.SendMouseParameters(GLI_MOUSE_CLICK, button, state, x, WindH-y);
	} else {
		iface_buttons.SendMouseParameters(GLI_MOUSE_CLICK, button, state, x, WindH-y);
	}
} /* }}} */
void mouse2(int x, int y){ /* {{{ */
	if (draw_iface==1){
		iface.SendMouseParameters(GLI_MOUSE_MOTION_BUTTON, GLI_MOUSE_BUTTON_NONE, GLI_MOUSE_BUTTON_NONE, x, WindH-y);
	}
	if (draw_iface_texture==1){
		iface_texture.SendMouseParameters(GLI_MOUSE_MOTION_BUTTON, GLI_MOUSE_BUTTON_NONE, GLI_MOUSE_BUTTON_NONE, x, WindH-y);
	}
	if (draw_iface_exit==1){
		iface_exit.SendMouseParameters(GLI_MOUSE_MOTION_BUTTON, GLI_MOUSE_BUTTON_NONE, GLI_MOUSE_BUTTON_NONE, x, WindH-y);
	} else {
		iface_buttons.SendMouseParameters(GLI_MOUSE_MOTION_BUTTON, GLI_MOUSE_BUTTON_NONE, GLI_MOUSE_BUTTON_NONE, x, WindH-y);
	}
} /* }}} */
void mouse3(int x, int y){ /* {{{ */
	if (draw_iface==1){
		iface.SendMouseParameters(GLI_MOUSE_MOTION, GLI_MOUSE_BUTTON_NONE, GLI_MOUSE_BUTTON_NONE, x, WindH-y);
	}
	if (draw_iface_texture==1){
		iface_texture.SendMouseParameters(GLI_MOUSE_MOTION, GLI_MOUSE_BUTTON_NONE, GLI_MOUSE_BUTTON_NONE, x, WindH-y);
	}
	if (draw_iface_exit==1){
		iface_exit.SendMouseParameters(GLI_MOUSE_MOTION, GLI_MOUSE_BUTTON_NONE, GLI_MOUSE_BUTTON_NONE, x, WindH-y);
	} else {
		iface_buttons.SendMouseParameters(GLI_MOUSE_MOTION, GLI_MOUSE_BUTTON_NONE, GLI_MOUSE_BUTTON_NONE, x, WindH-y);
	}
} /* }}} */
static void Key(unsigned char key, int x, int y){ /* {{{ */
	if (draw_iface==1){
		iface.SendKeyEvent(key, x, WindH-y);
	}
	if (draw_iface_texture==1){
		iface_texture.SendKeyEvent(key, x, WindH-y);
	}
	if (draw_iface_exit==1){
		iface_exit.SendKeyEvent(key, x, WindH-y);
	} else {
		iface_buttons.SendKeyEvent(key, x, WindH-y);
	}
} /* }}} */
void timf(int value){ /* {{{ */
	glutPostRedisplay();
	glutTimerFunc(1, timf, 0);
} /* }}} */
void CallBack_Exit(GLuint id, GLuint event_type){ /* {{{ */
	if (event_type == GLI_CLICKED){
		draw_iface=0;
		draw_iface_texture=0;
		draw_iface_exit=1;
	}
} /* }}} */
void CallBack_yes(GLuint id, GLuint event_type){ /* {{{ */
	if (event_type == GLI_CLICKED){
		exit(0);
	}
} /* }}} */
void CallBack_no(GLuint id, GLuint event_type){ /* {{{ */
	if (event_type == GLI_CLICKED){
		draw_iface=1;
		draw_iface_texture=1;
		draw_iface_exit=0;
	}
} /* }}} */
void CallBack_down(GLuint id, GLuint event_type){/*{{{*/
	if (event_type == GLI_CLICKED){
		if (direction == DOWN)
			direction=STOP;
		else
			direction=DOWN;
	}
}/*}}}*/
void CallBack_up(GLuint id, GLuint event_type){/*{{{*/
	if (event_type == GLI_CLICKED){
		if (direction == UP)
			direction=STOP;
		else
			direction=UP;
	}
}/*}}}*/
void CallBack_Button(GLuint id, GLuint event_type){ //{{{
	if (event_type == GLI_CLICKED){
		for (int x = 0; x <= items; x++){
			if (ids[x] == id){
#if DEBUG
				fprintf(stderr, "DEBUG: executing: '%s'\n", action[x]);
#endif
				system(action[x]);
			}
		}
	}
} // }}}
void readaline(int f, char *b){ //{{{
	char *w=b;
	
	memset(b, 0x0, 256);
	read(f, w, 1);
	while(strcmp(w, "\n") != 0){
		w++;
		read(f, w, 1);
	}
	memset(strchr(b, '\n'), 0x0, 1);
} // }}}
void Draw(void){ /* {{{ */
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glEnable(GL_TEXTURE_2D);
	glLoadIdentity();
	glPushMatrix();
	if (direction==UP)
		ifaceposition++;
	if (direction==DOWN)
		ifaceposition--;
	if (draw_iface_texture==1){
		glTranslatef(0,ifaceposition,0);
		iface_texture.Draw();
		glLoadIdentity();
	}
	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
	if (draw_iface==1){
		glTranslatef(0,ifaceposition,0);
		iface.Draw();
		glLoadIdentity();
	}
	if (draw_iface_exit==1){
		iface_exit.Draw();
	} else {
		iface_buttons.Draw();
	}
	glFlush();
	glutSwapBuffers();
} /* }}} */
void new_button(){ // {{{
	bool finished = false;

	CGLI_Button2D *object = new CGLI_Button2D();

	while(!finished){
		readaline(lvpxml, buf);
		work=buf;
		no_eternity=0;
		while (strncmp(work, "<", 1)){
			work++;
			no_eternity++;
#if DEBUG
			fprintf(stderr, "DEBUG: work: '%s' no_eternity: '%i' strcmp: '%i'\n", work, no_eternity, strncmp(work, "<", 1));
#endif
			if (no_eternity > 256){
				fprintf(stderr, "Not a valid lvp.xml file: %s\n", "lvp.xml");
				fprintf(stderr, "Got: '%s' Expected: '<'\n", buf);
				close(lvpxml);
				exit(1);
			}
		}
		if (strncmp(work, "<color", 6) == 0){/*{{{*/
			double r, g, b=r=g=0;
			char *rt=(char *)malloc(256), *rtw;
			char *gt=(char *)malloc(256), *gtw;
			char *bt=(char *)malloc(256), *btw;

			work = strstr(buf, "r=");
			memset(rt, 0x0, 256);
			memcpy(rt, work, strlen(work));
			rtw=rt+3;
			memset(strchr(rtw, '"'), 0x0, 1);
			r=atof(rtw);
			free(rt);

			work = strstr(buf, "g=");
			memset(gt, 0x0, 256);
			memcpy(gt, work, strlen(work));
			gtw=gt+3;
			memset(strchr(gtw, '"'), 0x0, 1);
			g=atof(gtw);
			free(gt);

			work = strstr(buf, "b=");
			memset(bt, 0x0, 256);
			memcpy(bt, work, strlen(work));
			btw=bt+3;
			memset(strchr(btw, '"'), 0x0, 1);
			b=atof(btw);
			free(bt);
#if DEBUG
			fprintf(stderr, "DEBUG: Color: r: '%f' g: '%f' b: '%f'\n", r, g, b);
#endif
			object->SetColor(r,g,b,1.0);
		}/*}}}*/
		else if (strncmp(work, "<mousecolor", 11) == 0){/*{{{*/
			double r, g, b=r=g=0;
			char *rt=(char *)malloc(256), *rtw;
			char *gt=(char *)malloc(256), *gtw;
			char *bt=(char *)malloc(256), *btw;

			work = strstr(buf, "r=");
			memset(rt, 0x0, 256);
			memcpy(rt, work, strlen(work));
			rtw=rt+3;
			memset(strchr(rtw, '"'), 0x0, 1);
			r=atof(rtw);
			free(rt);

			work = strstr(buf, "g=");
			memset(gt, 0x0, 256);
			memcpy(gt, work, strlen(work));
			gtw=gt+3;
			memset(strchr(gtw, '"'), 0x0, 1);
			g=atof(gtw);
			free(gt);

			work = strstr(buf, "b=");
			memset(bt, 0x0, 256);
			memcpy(bt, work, strlen(work));
			btw=bt+3;
			memset(strchr(btw, '"'), 0x0, 1);
			b=atof(btw);
			free(bt);

#if DEBUG
			fprintf(stderr, "DEBUG: r: '%f' g: '%f' b: '%f'\n", r, g, b);
#endif
			object->SetOnMouseColor(r,g,b,1.0);
		}/*}}}*/
		else if (strncmp(work, "<textcolor", 10) == 0){/*{{{*/
			double r, g, b=r=g=0;
			char *rt=(char *)malloc(256), *rtw;
			char *gt=(char *)malloc(256), *gtw;
			char *bt=(char *)malloc(256), *btw;

			work = strstr(buf, "r=");
			memset(rt, 0x0, 256);
			memcpy(rt, work, strlen(work));
			rtw=rt+3;
			memset(strchr(rtw, '"'), 0x0, 1);
			r=atof(rtw);
			free(rt);

			work = strstr(buf, "g=");
			memset(gt, 0x0, 256);
			memcpy(gt, work, strlen(work));
			gtw=gt+3;
			memset(strchr(gtw, '"'), 0x0, 1);
			g=atof(gtw);
			free(gt);

			work = strstr(buf, "b=");
			memset(bt, 0x0, 256);
			memcpy(bt, work, strlen(work));
			btw=bt+3;
			memset(strchr(btw, '"'), 0x0, 1);
			b=atof(btw);
			free(bt);

#if DEBUG
			fprintf(stderr, "DEBUG: r: '%f' g: '%f' b: '%f'\n", r, g, b);
#endif
			object->SetTextColor(r,g,b,1.0);
		}/*}}}*/
		else if (strncmp(work, "<action>", 8) == 0){/*{{{*/
			work += 8;
			memset(strstr(work, "</action>"), 0x0, 1);
			ids[items] = object->GetID();
			action[items] = (char *)malloc(256);
			memset(action[items], 0x0, 256);
			memcpy(action[items], work, strlen(work));
			items++;
		}/*}}}*/
		else if (strncmp(work, "<position", 9) == 0){/*{{{*/
			double x, y=x=0;
			char *xt=(char *)malloc(256), *xtw;
			char *yt=(char *)malloc(256), *ytw;

			work = strstr(buf, "x=");
			memset(xt, 0x0, 256);
			memcpy(xt, work, strlen(work));
			xtw=xt+3;
			memset(strchr(xtw, '"'), 0x0, 1);
			x=atof(xtw);
			free(xt);

			work = strstr(buf, "y=");
			memset(yt, 0x0, 256);
			memcpy(yt, work, strlen(work));
			ytw=yt+3;
			memset(strchr(ytw, '"'), 0x0, 1);
			y=atof(ytw);
			free(yt);

#if DEBUG
			fprintf(stderr, "DEBUG: x: '%f' y:'%f'\n", x, y);
#endif

			object->SetPosition(x, y, 0);
		}/*}}}*/
		else if (strncmp(work, "<size", 5) == 0){/*{{{*/
			double h, w=h=0;
			char *ht=(char *)malloc(256), *htw;
			char *wt=(char *)malloc(256), *wtw;

			work = strstr(buf, "h=");
			memset(ht, 0x0, 256);
			memcpy(ht, work, strlen(work));
			htw=ht+3;
			memset(strchr(htw, '"'), 0x0, 1);
			h=atof(htw);
			free(ht);

			work = strstr(buf, "w=");
			memset(wt, 0x0, 256);
			memcpy(wt, work, strlen(work));
			wtw=wt+3;
			memset(strchr(wtw, '"'), 0x0, 1);
			w=atof(wtw);
			free(wt);

#if DEBUG
			fprintf(stderr, "DEBUG: h: '%f' w:'%f'\n", h, w);
#endif

			object->SetDimensions(w, h, 0);
		}/*}}}*/
		else if (strncmp(work, "<text>", 6) == 0){/*{{{*/
			work += 6;
			memset(strstr(work, "</text>"), 0x0, 1);
			object->SetButtonText(work);
		}/*}}}*/
		else if (strncmp(work, "</item>", 7) == 0){/*{{{*/
#if DEBUG
			fprintf(stderr, "DEBUG: Ending this item\n");
#endif
			object->SetCallBackFunction(CallBack_Button);
			iface.AddObject(object);
			finished=true;
		}/*}}}*/
		else {/*{{{*/
			fprintf(stderr, "Unkown attribute: '%s'\n", buf);
			close(lvpxml);
			exit(1);
		}/*}}}*/
	}
} // }}}
void relocate_button_exit(){ // {{{
	bool finished = false;

	CGLI_Button2D *object = new CGLI_Button2D();

	while(!finished){
		readaline(lvpxml, buf);
		work=buf;
		no_eternity=0;
		while (strncmp(work, "<", 1)){
			work++;
			no_eternity++;
#if DEBUG
			fprintf(stderr, "DEBUG: work: '%s' no_eternity: '%i' strcmp: '%i'\n", work, no_eternity, strncmp(work, "<", 1));
#endif
			if (no_eternity > 256){
				fprintf(stderr, "Not a valid lvp.xml file: %s\n", "lvp.xml");
				fprintf(stderr, "Got: '%s' Expected: '<'\n", buf);
				close(lvpxml);
				exit(1);
			}
		}
		if (strncmp(work, "<color", 6) == 0){/*{{{*/
			double r, g, b=r=g=0;
			char *rt=(char *)malloc(256), *rtw;
			char *gt=(char *)malloc(256), *gtw;
			char *bt=(char *)malloc(256), *btw;

			work = strstr(buf, "r=");
			memset(rt, 0x0, 256);
			memcpy(rt, work, strlen(work));
			rtw=rt+3;
			memset(strchr(rtw, '"'), 0x0, 1);
			r=atof(rtw);
			free(rt);

			work = strstr(buf, "g=");
			memset(gt, 0x0, 256);
			memcpy(gt, work, strlen(work));
			gtw=gt+3;
			memset(strchr(gtw, '"'), 0x0, 1);
			g=atof(gtw);
			free(gt);

			work = strstr(buf, "b=");
			memset(bt, 0x0, 256);
			memcpy(bt, work, strlen(work));
			btw=bt+3;
			memset(strchr(btw, '"'), 0x0, 1);
			b=atof(btw);
			free(bt);
#if DEBUG
			fprintf(stderr, "DEBUG: Color: r: '%f' g: '%f' b: '%f'\n", r, g, b);
#endif
			button_exit.SetColor(r,g,b,1.0);
		} /* }}} */
		else if (strncmp(work, "<mousecolor", 11) == 0){/*{{{*/
			double r, g, b=r=g=0;
			char *rt=(char *)malloc(256), *rtw;
			char *gt=(char *)malloc(256), *gtw;
			char *bt=(char *)malloc(256), *btw;

			work = strstr(buf, "r=");
			memset(rt, 0x0, 256);
			memcpy(rt, work, strlen(work));
			rtw=rt+3;
			memset(strchr(rtw, '"'), 0x0, 1);
			r=atof(rtw);
			free(rt);

			work = strstr(buf, "g=");
			memset(gt, 0x0, 256);
			memcpy(gt, work, strlen(work));
			gtw=gt+3;
			memset(strchr(gtw, '"'), 0x0, 1);
			g=atof(gtw);
			free(gt);

			work = strstr(buf, "b=");
			memset(bt, 0x0, 256);
			memcpy(bt, work, strlen(work));
			btw=bt+3;
			memset(strchr(btw, '"'), 0x0, 1);
			b=atof(btw);
			free(bt);

#if DEBUG
			fprintf(stderr, "DEBUG: r: '%f' g: '%f' b: '%f'\n", r, g, b);
#endif
			button_exit.SetOnMouseColor(r,g,b,1.0);
		} /* }}} */
		else if (strncmp(work, "<textcolor", 10) == 0){/*{{{*/
			double r, g, b=r=g=0;
			char *rt=(char *)malloc(256), *rtw;
			char *gt=(char *)malloc(256), *gtw;
			char *bt=(char *)malloc(256), *btw;

			work = strstr(buf, "r=");
			memset(rt, 0x0, 256);
			memcpy(rt, work, strlen(work));
			rtw=rt+3;
			memset(strchr(rtw, '"'), 0x0, 1);
			r=atof(rtw);
			free(rt);

			work = strstr(buf, "g=");
			memset(gt, 0x0, 256);
			memcpy(gt, work, strlen(work));
			gtw=gt+3;
			memset(strchr(gtw, '"'), 0x0, 1);
			g=atof(gtw);
			free(gt);

			work = strstr(buf, "b=");
			memset(bt, 0x0, 256);
			memcpy(bt, work, strlen(work));
			btw=bt+3;
			memset(strchr(btw, '"'), 0x0, 1);
			b=atof(btw);
			free(bt);

#if DEBUG
			fprintf(stderr, "DEBUG: r: '%f' g: '%f' b: '%f'\n", r, g, b);
#endif
			button_exit.SetTextColor(r,g,b,1.0);
		}/*}}}*/
		else if (strncmp(work, "<position", 9) == 0){/*{{{*/
			double x, y=x=0;
			char *xt=(char *)malloc(256), *xtw;
			char *yt=(char *)malloc(256), *ytw;

			work = strstr(buf, "x=");
			memset(xt, 0x0, 256);
			memcpy(xt, work, strlen(work));
			xtw=xt+3;
			memset(strchr(xtw, '"'), 0x0, 1);
			x=atof(xtw);
			free(xt);

			work = strstr(buf, "y=");
			memset(yt, 0x0, 256);
			memcpy(yt, work, strlen(work));
			ytw=yt+3;
			memset(strchr(ytw, '"'), 0x0, 1);
			y=atof(ytw);
			free(yt);

#if DEBUG
			fprintf(stderr, "DEBUG: x: '%f' y:'%f'\n", x, y);
#endif

			button_exit.SetPosition(x, y, 0);
		}/*}}}*/
		else if (strncmp(work, "<size", 5) == 0){/*{{{*/
			double h, w=h=0;
			char *ht=(char *)malloc(256), *htw;
			char *wt=(char *)malloc(256), *wtw;

			work = strstr(buf, "h=");
			memset(ht, 0x0, 256);
			memcpy(ht, work, strlen(work));
			htw=ht+3;
			memset(strchr(htw, '"'), 0x0, 1);
			h=atof(htw);
			free(ht);

			work = strstr(buf, "w=");
			memset(wt, 0x0, 256);
			memcpy(wt, work, strlen(work));
			wtw=wt+3;
			memset(strchr(wtw, '"'), 0x0, 1);
			w=atof(wtw);
			free(wt);

#if DEBUG
			fprintf(stderr, "DEBUG: h: '%f' w:'%f'\n", h, w);
#endif

			button_exit.SetDimensions(w, h, 0);
		}/*}}}*/
		else if (strncmp(work, "<text>", 6) == 0){/*{{{*/
			work += 6;
			memset(strstr(work, "</text>"), 0x0, 1);
			button_exit.SetButtonText(work);
		}/*}}}*/
		else if (strncmp(work, "</item>", 7) == 0){/*{{{*/
#if DEBUG
			fprintf(stderr, "DEBUG: Ending this item\n");
#endif
			finished=true;
		}/*}}}*/
		else {/*{{{*/
			fprintf(stderr, "Unkown attribute: '%s'\n", buf);
			close(lvpxml);
			exit(1);
		}/*}}}*/
	}
} // }}}
void new_buttontexture(){ // {{{
	bool finished = false;

	CGLI_ButtonTexture *object = new CGLI_ButtonTexture();

	while(!finished){
		readaline(lvpxml, buf);
		work=buf;
		no_eternity=0;
		while (strncmp(work, "<", 1)){
			work++;
			no_eternity++;
#if DEBUG
			fprintf(stderr, "DEBUG: work: '%s' no_eternity: '%i' strcmp: '%i'\n", work, no_eternity, strncmp(work, "<", 1));
#endif
			if (no_eternity > 256){
				fprintf(stderr, "Not a valid lvp.xml file: %s\n", "lvp.xml");
				fprintf(stderr, "Got: '%s' Expected: '<'\n", buf);
				close(lvpxml);
				exit(1);
			}
		}
		if (strncmp(work, "<action>", 8) == 0){/*{{{*/
			work += 8;
			memset(strstr(work, "</action>"), 0x0, 1);
			ids[items] = object->GetID();
			action[items] = (char *)malloc(256);
			memset(action[items], 0x0, 256);
			memcpy(action[items], work, strlen(work));
			items++;
		}/*}}}*/
		else if (strncmp(work, "<position", 9) == 0){/*{{{*/
			double x, y=x=0;
			char *xt=(char *)malloc(256), *xtw;
			char *yt=(char *)malloc(256), *ytw;

			work = strstr(buf, "x=");
			memset(xt, 0x0, 256);
			memcpy(xt, work, strlen(work));
			xtw=xt+3;
			memset(strchr(xtw, '"'), 0x0, 1);
			x=atof(xtw);
			free(xt);

			work = strstr(buf, "y=");
			memset(yt, 0x0, 256);
			memcpy(yt, work, strlen(work));
			ytw=yt+3;
			memset(strchr(ytw, '"'), 0x0, 1);
			y=atof(ytw);
			free(yt);

#if DEBUG
			fprintf(stderr, "DEBUG: x: '%f' y:'%f'\n", x, y);
#endif

			object->SetPosition(x, y, 0);
		}/*}}}*/
		else if (strncmp(work, "<size", 5) == 0){/*{{{*/
			double h, w=h=0;
			char *ht=(char *)malloc(256), *htw;
			char *wt=(char *)malloc(256), *wtw;

			work = strstr(buf, "h=");
			memset(ht, 0x0, 256);
			memcpy(ht, work, strlen(work));
			htw=ht+3;
			memset(strchr(htw, '"'), 0x0, 1);
			h=atof(htw);
			free(ht);

			work = strstr(buf, "w=");
			memset(wt, 0x0, 256);
			memcpy(wt, work, strlen(work));
			wtw=wt+3;
			memset(strchr(wtw, '"'), 0x0, 1);
			w=atof(wtw);
			free(wt);

#if DEBUG
			fprintf(stderr, "DEBUG: h: '%f' w:'%f'\n", h, w);
#endif

			object->SetDimensions(w, h, 0);
		}/*}}}*/
		else if (strncmp(work, "<texture", 8) == 0){/*{{{*/
			char *nt=(char *)malloc(256), *ntw;
			char *ot=(char *)malloc(256), *otw;
			char *pt=(char *)malloc(256), *ptw;
			GLuint normal, over, pressed;
			
			work = strstr(buf, "normal=");
			memset(nt, 0x0, 256);
			memcpy(nt, work, strlen(work));
			ntw=nt+8;
			memset(strchr(ntw, '"'), 0x0, 1);
			normal=iface_texture.LoadTextureFromFile(ntw);
#if DEBUG
			fprintf(stderr, "DEBUG: normal texture: '%s' - %i\n", ntw, normal);
#endif
			object->SetNormalTexture(normal);

			work = strstr(buf, "over=");
			memset(ot, 0x0, 256);
			memcpy(ot, work, strlen(work));
			otw=ot+6;
			memset(strchr(otw, '"'), 0x0, 1);
			over=iface_texture.LoadTextureFromFile(otw);
#if DEBUG
			fprintf(stderr, "DEBUG: over texture: '%s' - %i\n", otw, over);
#endif
			object->SetOnOverTexture(over);

			work = strstr(buf, "pressed=");
			memset(pt, 0x0, 256);
			memcpy(pt, work, strlen(work));
			ptw=pt+9;
			memset(strchr(ptw, '"'), 0x0, 1);
			pressed=iface_texture.LoadTextureFromFile(ptw);
#if DEBUG
			fprintf(stderr, "DEBUG: pressed texture: '%s' - %i\n", ptw, pressed);
#endif
			object->SetPressedTexture(pressed);
		}/*}}}*/
		else if (strncmp(work, "</item>", 7) == 0){/*{{{*/
#if DEBUG
			fprintf(stderr, "DEBUG: Ending this item\n");
#endif
			object->SetCallBackFunction(CallBack_Button);
			iface_texture.AddObject(object);
			finished=true;
		}/*}}}*/
		else {/*{{{*/
			fprintf(stderr, "Unkown attribute: '%s'\n", buf);
			close(lvpxml);
			exit(1);
		}/*}}}*/
	}
} // }}}
void new_text(){ // {{{
	bool finished = false;

	CGLI_String *object = new CGLI_String();

	while(!finished){
		readaline(lvpxml, buf);
		work=buf;
		no_eternity=0;
		while (strncmp(work, "<", 1)){
			work++;
			no_eternity++;
#if DEBUG
			fprintf(stderr, "DEBUG: work: '%s' no_eternity: '%i' strcmp: '%i'\n", work, no_eternity, strncmp(work, "<", 1));
#endif
			if (no_eternity > 256){
				fprintf(stderr, "Not a valid lvp.xml file: %s\n", "lvp.xml");
				fprintf(stderr, "Got: '%s' Expected: '<'\n", buf);
				close(lvpxml);
				exit(1);
			}
		}
		if (strncmp(work, "<position", 9) == 0){/*{{{*/
			double x, y=x=0;
			char *xt=(char *)malloc(256), *xtw;
			char *yt=(char *)malloc(256), *ytw;

			work = strstr(buf, "x=");
			memset(xt, 0x0, 256);
			memcpy(xt, work, strlen(work));
			xtw=xt+3;
			memset(strchr(xtw, '"'), 0x0, 1);
			x=atof(xtw);
			free(xt);

			work = strstr(buf, "y=");
			memset(yt, 0x0, 256);
			memcpy(yt, work, strlen(work));
			ytw=yt+3;
			memset(strchr(ytw, '"'), 0x0, 1);
			y=atof(ytw);
			free(yt);

#if DEBUG
			fprintf(stderr, "DEBUG: x: '%f' y:'%f'\n", x, y);
#endif

			object->SetPosition(x, y, 0);
		}/*}}}*/
		else if (strncmp(work, "<size", 5) == 0){/*{{{*/
			double h, w=h=0;
			char *ht=(char *)malloc(256), *htw;
			char *wt=(char *)malloc(256), *wtw;

			work = strstr(buf, "h=");
			memset(ht, 0x0, 256);
			memcpy(ht, work, strlen(work));
			htw=ht+3;
			memset(strchr(htw, '"'), 0x0, 1);
			h=atof(htw);
			free(ht);

			work = strstr(buf, "w=");
			memset(wt, 0x0, 256);
			memcpy(wt, work, strlen(work));
			wtw=wt+3;
			memset(strchr(wtw, '"'), 0x0, 1);
			w=atof(wtw);
			free(wt);

#if DEBUG
			fprintf(stderr, "DEBUG: h: '%f' w:'%f'\n", h, w);
#endif

			object->SetDimensions(w, h, 0);
		}/*}}}*/
		else if (strncmp(work, "<text>", 6) == 0){/*{{{*/
			work += 6;
			memset(strstr(work, "</text>"), 0x0, 1);
			object->SetString(work);
		}/*}}}*/
		else if (strncmp(work, "</item>", 7) == 0){/*{{{*/
#if DEBUG
			fprintf(stderr, "DEBUG: Ending this item\n");
#endif
			object->SetFontType(GLI_FONT_VECTOR);
			object->SetStringCentering(true);
			iface.AddObject(object);
			finished=true;
		}/*}}}*/
		else {/*{{{*/
			fprintf(stderr, "Unkown attribute: '%s'\n", buf);
			close(lvpxml);
			exit(1);
		}/*}}}*/
	}
} // }}}
int main(int argc, char *argv[]){ // {{{
	if (argc > 1){
		lvpxml = open (argv[1], O_RDONLY);
		if (lvpxml == -1){
			char *errmsg = (char *)malloc(256);
			sprintf(errmsg, "Couldn't open %s", argv[1]);
			perror(errmsg);
			free(errmsg);
			fprintf(stderr, "Falling back to hardcoded file ./lvp.xml\n");
			lvpxml = open("lvp.xml", O_RDONLY);
			if (lvpxml == -1){
				perror("Couldn't open lvp.xml");
				exit(1);
			}
		}
	} else {
		lvpxml = open("lvp.xml", O_RDONLY);
		if (lvpxml == -1){
			perror("Couldn't open lvp.xml");
			exit(1);
		}
	}
	buf = (char *)malloc(256);
	WindW = 800;
	WindH = 600;
	items = 0;

	readaline(lvpxml, buf);
#if DEBUG
	fprintf(stderr, "DEBUG: buf: '%s'\n", buf);
#endif
	if (strncmp(buf, "<lvp>", 5) != 0){
		fprintf(stderr, "Not a valid lvp.xml file: %s\n", "lvp.xml");
		fprintf(stderr, "Got: '%s' Expected: '<lvp>' strcmp said: %i\n", buf, strncmp(buf, "<lvp>", 5));
		close(lvpxml);
		exit(1);
	}

	glutInit(&argc, argv);
	glutInitWindowPosition (0,0);
	glutInitWindowSize(WindW, WindH);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	(void)glutCreateWindow("LVP");

	glutReshapeFunc(Reshape);
	glutDisplayFunc(Draw);
	glutMouseFunc(mouse);
	glutMotionFunc(mouse2);
	glutPassiveMotionFunc(mouse3);
	glutKeyboardFunc(Key);
	glutTimerFunc(10, timf, 0);
	glClearColor(0, 0, 0, 0);
	glColor3f(1, 1, 1);

	/* setting some defaults */
	button_exit.SetCallBackFunction(CallBack_Exit);
	button_exit.SetButtonText("X");
	button_exit.SetDimensions(10, 10, 0);
	button_exit.SetPosition(120, 80, 0);
	button_exit.SetTextColor(0,1,1,1.0);
	button_exit.SetOnMouseColor(1.0,0.5,0.5,1.0);
	button_exit.SetColor(1,0,0,1.0);
	iface_buttons.AddObject(&button_exit);

	reading=1;
	while (reading == 1){
		readaline(lvpxml, buf);
		work=buf;
		no_eternity=0;
		while (strncmp(work, "<", 1) != 0){
			work++;
			no_eternity++;
#if DEBUG
			fprintf(stderr, "DEBUG: work: '%s' no_eternity: '%i' strcmp: '%i'\n", work, no_eternity, strncmp(work, "<", 1));
#endif
			if (no_eternity > 256){
				fprintf(stderr, "Not a valid lvp.xml file: %s\n", "lvp.xml");
				fprintf(stderr, "Got: '%s' Expected: '<'\n", buf);
				close(lvpxml);
				exit(1);
			}
		}
#if DEBUG
		fprintf(stderr, "DEBUG: Got '%s'\n", work);
#endif
		if (strncmp(buf, "</lvp>", 6) == 0){
			reading = 0;
		} else {
			work += 12;
			memset(strchr(work, '"'), 0x0, 1);
			if (strcmp(work, "button") == 0){
				new_button();
			} else if (strcmp(work, "buttontexture") == 0){
				new_buttontexture();
			} else if (strcmp(work, "text") == 0){
				new_text();
			} else if (strcmp(work, "button_exit") == 0){
				relocate_button_exit();
			} else {
				fprintf(stderr, "Unknown/Unimplemented Itemtype: '%s'\n", work);
				exit(1);
			}
		}
	}

	window.SetPosition(0, 0, 0);
	window.SetDimensions(80, 80, 1);
	window.SetCaptionHeight(5);
	window_text.SetStringCentering(GL_TRUE);
	window_text.SetPosition(0, 37.5, 1);
	window_text.SetDimensions(5, 3, 1);
	window_text.SetString("Please confirm");
	memo.SetDimensions(3, 3, 1);
	memo.AddNewString("Do you really");
	memo.AddNewString("want to leave?");
	memo.SetTextCentering(GL_TRUE);
	no.SetDimensions(20, 6, 0);
	no.SetPosition(28, -35, 0);
	no.SetBorderSize(0.3);
	no.SetButtonText("No");
	no.SetCallBackFunction(CallBack_no);
	yes.SetDimensions(20, 6, 0);
	yes.SetPosition(-28, -35, 0);
	yes.SetBorderSize(0.3);
	yes.SetButtonText("Yes");
	yes.SetCallBackFunction(CallBack_yes);
	up.SetDimensions(10,10,0);
	up.SetPosition(120,7,0);
	up.SetBorderSize(0.5);
	up.SetButtonText("U");
	up.SetCallBackFunction(CallBack_up);
	down.SetDimensions(10,10,0);
	down.SetPosition(120,-7,0);
	down.SetBorderSize(0.5);
	down.SetButtonText("D");
	down.SetCallBackFunction(CallBack_down);
	iface_buttons.AddObject(&up);
	iface_buttons.AddObject(&down);
	iface_exit.AddObject(&window);
	iface_exit.AddObject(&window_text);
	window.AddObject(&memo);
	window.AddObject(&yes);
	window.AddObject(&no);

	if (items == 1){
		system(action[0]);
	}
	glutFullScreen();
	Reshape(WindW, WindH);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_TEXTURE_2D);
	glutMainLoop();
	
	return 0;
} // }}}
